/**************************************************************************************************
 * Project name:
     Decoder.c
 * Generated by:
     MikroC
 * Date of creation
     2014/07/16
 * Time of creation
     10:13:00 AM
 * Test configuration:
     MCU:             STM32F407VG
     Dev.Board:       MINI-M4 for STM32
     Oscillator:      16 MHz internal
     PLL:             120 MHz
     SW:              mikroC PRO for ARM
 * External hardware:
     Shaft encoder Digi-Key part number 102-191-ND connected to PA0 and PA1.
     Power taken from 3.3V and GND pins on MINI-M4.

**************************************************************************************************/

// Include Files
#include "USB_Driver.h"
#include "Timers.h"
#include "QuadDecoder.h"



// Variables
unsigned short int MainTimer;          // Timer handle for this module




// Program enty point
void main() {
     
     USB_Init();                       // Initialize USB
     
     Timer_Init();                     // Initialize timers
     MainTimer = get_timer();          // Get a timer handle
     set_timer(MainTimer,2000);        // Set timer

     // Delay while USB enumerates
     while (check_timer(MainTimer) != 0) {
     }
     USB_PutQueue("Started\r\n");
     
     Ext_Int_Init();                   // Initialize external interrupt pins for shaft encoder
     
     
     
     EnableInterrupts();               // Global enable interrupts
     
     // Main loop
     while (1) {
         
         USB_CheckIn();                // Check for incoming USB messages
         USB_CheckOut();               // Check for outgoing USB messages

         TimerCheck();                 // Check timer pool
     
         Decoder_SM();                 // Do decoder state machine
     }
}

/**************************************************************************************************
  EOF
**************************************************************************************************/