_SystemTimerInterrupt:
;Timers.c,21 :: 		void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,22 :: 		if (COUNTFLAG_bit) {              // Interrupts every millisecond
MOVW	R0, #lo_addr(COUNTFLAG_bit+0)
MOVT	R0, #hi_addr(COUNTFLAG_bit+0)
LDR	R1, [R0, #0]
UBFX	R0, R1, BitPos(COUNTFLAG_bit+0), #1
CMP	R0, #0
IT	EQ
BEQ	L_SystemTimerInterrupt0
;Timers.c,23 :: 		irqhandler_timer();           // Service timer pool
BL	_irqhandler_timer+0
;Timers.c,25 :: 		Msec += 1;                    // Increment millisecond counter
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
LDRH	R0, [R0, #0]
ADDS	R1, R0, #1
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;Timers.c,26 :: 		if (Msec > 999) {             // When counter goes to 1000
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
LDRH	R1, [R0, #0]
MOVW	R0, #999
CMP	R1, R0
IT	LS
BLS	L_SystemTimerInterrupt1
;Timers.c,27 :: 		Msec = 0;                 // Set it to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;Timers.c,28 :: 		TimerFlag = 1;            // Set 1 second flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,29 :: 		}
L_SystemTimerInterrupt1:
;Timers.c,30 :: 		}
L_SystemTimerInterrupt0:
;Timers.c,31 :: 		}
L_end_SystemTimerInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SystemTimerInterrupt
_Timer_Init:
;Timers.c,35 :: 		void Timer_Init() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,36 :: 		init_timerpool();                 // Make all timers free
BL	_init_timerpool+0
;Timers.c,39 :: 		NVIC_SYSTICKRVR = 15000;          // Set reload value register for 120 MHz
MOVW	R1, #15000
MOVW	R0, #lo_addr(NVIC_SYSTICKRVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKRVR+0)
STR	R1, [R0, #0]
;Timers.c,40 :: 		NVIC_SYSTICKCVR = 0;              // Reset timer counter
MOVS	R1, #0
MOVW	R0, #lo_addr(NVIC_SYSTICKCVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKCVR+0)
STR	R1, [R0, #0]
;Timers.c,41 :: 		ENABLE_SYSTICKCSR_bit = 1;        // Enable timer
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(ENABLE_SYSTICKCSR_bit+0)
MOVT	R1, #hi_addr(ENABLE_SYSTICKCSR_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(ENABLE_SYSTICKCSR_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,42 :: 		TICKINT_bit = 1;                  // Enable timer interrupt
MOVW	R1, #lo_addr(TICKINT_bit+0)
MOVT	R1, #hi_addr(TICKINT_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(TICKINT_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,43 :: 		}
L_end_Timer_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer_Init
_TimerCheck:
;Timers.c,47 :: 		void TimerCheck() {
;Timers.c,48 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck2
;Timers.c,49 :: 		TimerFlag = 0;                // Reset 1 second flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,52 :: 		}
L_TimerCheck2:
;Timers.c,53 :: 		}
L_end_TimerCheck:
BX	LR
; end of _TimerCheck
_init_timerpool:
;Timers.c,84 :: 		void init_timerpool(void) {
SUB	SP, SP, #4
;Timers.c,87 :: 		for (i=0; i < NUMTIMERS; i++) {
MOVS	R0, #0
STRB	R0, [SP, #0]
L_init_timerpool3:
LDRB	R0, [SP, #0]
CMP	R0, #10
IT	CS
BCS	L_init_timerpool4
;Timers.c,88 :: 		TimerPool[i].TimerField = 0;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
MOV	R1, R0
MOVS	R0, #0
STR	R0, [R1, #0]
;Timers.c,89 :: 		TimerPool[i].Free = TRUE;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timers.c,87 :: 		for (i=0; i < NUMTIMERS; i++) {
LDRB	R0, [SP, #0]
ADDS	R0, R0, #1
STRB	R0, [SP, #0]
;Timers.c,90 :: 		}
IT	AL
BAL	L_init_timerpool3
L_init_timerpool4:
;Timers.c,91 :: 		}
L_end_init_timerpool:
ADD	SP, SP, #4
BX	LR
; end of _init_timerpool
_get_timer:
;Timers.c,99 :: 		unsigned short int get_timer(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;Timers.c,102 :: 		for (i=0; i < NUMTIMERS; i++) {
MOVS	R0, #0
STRB	R0, [SP, #4]
L_get_timer6:
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	CS
BCS	L_get_timer7
;Timers.c,103 :: 		if (TimerPool[i].Free == TRUE) {  // If a free timer is found
LDRB	R1, [SP, #4]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer9
;Timers.c,104 :: 		TimerPool[i].Free = FALSE;    // Mark it reserved
LDRB	R1, [SP, #4]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;Timers.c,105 :: 		return i;                     // Return timer handle
LDRB	R0, [SP, #4]
IT	AL
BAL	L_end_get_timer
;Timers.c,106 :: 		}
L_get_timer9:
;Timers.c,102 :: 		for (i=0; i < NUMTIMERS; i++) {
LDRB	R0, [SP, #4]
ADDS	R0, R0, #1
STRB	R0, [SP, #4]
;Timers.c,107 :: 		}
IT	AL
BAL	L_get_timer6
L_get_timer7:
;Timers.c,110 :: 		USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");
MOVW	R0, #lo_addr(?lstr1_Timers+0)
MOVT	R0, #hi_addr(?lstr1_Timers+0)
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;Timers.c,111 :: 		SystemReset();
BL	_SystemReset+0
;Timers.c,112 :: 		return (0);
MOVS	R0, #0
;Timers.c,113 :: 		}
L_end_get_timer:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _get_timer
_free_timer:
;Timers.c,121 :: 		void free_timer(unsigned short int nbr) {
;Timers.c,122 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
LDRB	R0, [SP, #0]
CMP	R0, #9
IT	LS
BLS	L_free_timer10
;Timers.c,123 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer10:
;Timers.c,125 :: 		TimerPool[nbr].Free = TRUE;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timers.c,126 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;Timers.c,135 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
;Timers.c,136 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
LDRB	R0, [SP, #0]
CMP	R0, #9
IT	LS
BLS	L_set_timer11
;Timers.c,137 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer11:
;Timers.c,139 :: 		if (TimerPool[nbr].Free == TRUE)
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_set_timer12
;Timers.c,140 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer12:
;Timers.c,142 :: 		TimerPool[nbr].TimerField = tout;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
MOV	R1, R0
LDR	R0, [SP, #4]
STR	R0, [R1, #0]
;Timers.c,143 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;Timers.c,151 :: 		unsigned long int check_timer(unsigned short int nbr) {
;Timers.c,152 :: 		return TimerPool[nbr].TimerField;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
;Timers.c,153 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;Timers.c,161 :: 		void irqhandler_timer(void) {
SUB	SP, SP, #4
;Timers.c,164 :: 		for (i=0; i<NUMTIMERS; i++) {
MOVS	R0, #0
STRB	R0, [SP, #0]
L_irqhandler_timer13:
LDRB	R0, [SP, #0]
CMP	R0, #10
IT	CS
BCS	L_irqhandler_timer14
;Timers.c,165 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_irqhandler_timer18
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_irqhandler_timer18
L__irqhandler_timer19:
;Timers.c,166 :: 		TimerPool[i].TimerField--;
LDRB	R1, [SP, #0]
MOVS	R0, #8
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
MOV	R1, R0
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
L_irqhandler_timer18:
;Timers.c,164 :: 		for (i=0; i<NUMTIMERS; i++) {
LDRB	R0, [SP, #0]
ADDS	R0, R0, #1
STRB	R0, [SP, #0]
;Timers.c,167 :: 		}
IT	AL
BAL	L_irqhandler_timer13
L_irqhandler_timer14:
;Timers.c,168 :: 		}
L_end_irqhandler_timer:
ADD	SP, SP, #4
BX	LR
; end of _irqhandler_timer
